/*
 * "Grundkurs Programmieren in Java (6. Auflage, 2011)"
 * 2003-2011, Carl Hanser Verlag
 * Loesungsvorschlag zu Aufgabe 12.6 (Version 2.0)
 * (c) 2003-2011 D. Ratz, J. Scheffler, D. Seese, J. Wiesenberger
 *
 */
import java.math.BigInteger;

public class BinomialKoeffizient {
  
  private static BigInteger ONE = BigInteger.valueOf(1);

  private static long zeit;
  
  /** Hilfsmethode: startet die Stoppuhr */
  private static void tick() {
    zeit = System.currentTimeMillis();
  }
  
  /** Hilfsmethode: stoppt die aktuelle Zeit */
  private static long tock() {
    return System.currentTimeMillis() - zeit;
  }
  
  /** Berechnet den Binomialkoeffizienten mit Hilfe der
    * Fakultaets-Methode
    **/
  public static BigInteger binKoeffFak(BigInteger m,BigInteger k) {
    BigInteger differenz = m.subtract(k);
    return BigFakul.fakultaet(m).divide(
           BigFakul.fakultaet(k).multiply(
           BigFakul.fakultaet(differenz)));
  }
  
  /** Berechnet den Binomialkoeffizienten explizit */
  public static BigInteger binKoeff(BigInteger m,BigInteger k) {
    BigInteger res = ONE;
    for(BigInteger i = ONE; i.compareTo(k) <= 0; i = i.add(ONE)) {
      res = res.multiply(m).divide(i);
      m = m.subtract(ONE);
    }
    return res;
  }
  
  /** Testet funktionalitaet und performance der beiden Methoden */ 
  public static void main (String[] args) {
    // Funktionstest:
    System.out.println("Funktionstest...");
    BigInteger koeff1 = binKoeffFak(
      BigInteger.valueOf(151),BigInteger.valueOf(53));
    BigInteger koeff2 = binKoeff(
      BigInteger.valueOf(151),BigInteger.valueOf(53));
    if (koeff1.equals(koeff2))
      System.out.println("...bestanden");
    else {
      System.out.println("...fehlgeschlagen: " + koeff1
        + " und " + koeff2);
      return;
    }
    // Zeittest:
    System.out.println("Zeittest...");
    tick();
    koeff1 = binKoeffFak(
      BigInteger.valueOf(5500),BigInteger.valueOf(1523));
    System.out.println("Mit Fakultaet   : " + tock() + " Millisekunden");
    tick();
    koeff2 = binKoeff(
      BigInteger.valueOf(5500),BigInteger.valueOf(1523));    
    System.out.println("Explizite Formel: " + tock() + " Millisekunden");
  }
}
