/*
 * "Grundkurs Programmieren in Java (6. Auflage, 2011)"
 * 2003-2011, Carl Hanser Verlag
 * Loesungsvorschlag zu Aufgabe 16.4 (Version 2.0)
 * (c) 2003-2011 D. Ratz, J. Scheffler, D. Seese, J. Wiesenberger
 *
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class DrehPanel extends JPanel {
  
  private JButton linksButton, rechtsButton, streckeButton, dreieckButton;
          
  public static final double SCHRITTWEITE = Math.PI / 60.0;

  private GeoObjekt drehObjekt;
  
  public DrehPanel() {
    drehObjekt = erzeugeStrecke();
    
    setLayout(new FlowLayout() );
    setOpaque(false);

    add(linksButton   = new JButton("Links"));
    add(rechtsButton  = new JButton("Rechts"));
    add(streckeButton = new JButton("Strecke"));
    add(dreieckButton = new JButton("Dreieck"));
    
    // Event-Handler
    linksButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        drehObjekt.drehen(-SCHRITTWEITE);
        repaint();
      }
    });
    
    rechtsButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        drehObjekt.drehen(SCHRITTWEITE);
        repaint();
      }
    });
    
    streckeButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        drehObjekt = erzeugeStrecke();
        repaint();
      }
    });
    
    dreieckButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        drehObjekt = erzeugeDreieck();
        repaint();
      }
    });
  } 
  
  public GeoObjekt erzeugeStrecke() {
    return new Strecke(new Punkt(0,0), new Punkt(100,0) );
  }
  
  public GeoObjekt erzeugeDreieck() {
    return new Dreieck(new Punkt(0,0), new Punkt(100,0), new Punkt(50, -66));
  }
  
  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    drehObjekt.zeichnen(g, this.getWidth()/2, this.getHeight()/2);
  }
} 
