/*
 * "Grundkurs Programmieren in Java - (6. Auflage, 2011)"
 * 2001-2011, Carl Hanser Verlag
 * Loesungsvorschlag zu Aufgabe 8.8 (Version 3.0)
 * (c) 2001-2011 D. Ratz, J. Scheffler, D. Seese, J. Wiesenberger
 *
 */

public class TennisSpieler {

  public String name;                     // Name des Spielers
  public int alter;                       // Alter in Jahren

  public TennisSpieler verfolger = null;  // Verfolger in der Weltrangliste
  private int startNummer;                // Startnummer in einem Wettbewerb
  private static int folgeNummer = 1;     // Naechste Nummer

  public TennisSpieler (String name, int alter) {
    this.name = name;
    this.alter = alter;
    startNummer = folgeNummer++;
  }

  public TennisSpieler (String name, int alter, TennisSpieler verfolger) {
    this.name = name;
    this.alter = alter;
    this.verfolger = verfolger;
    startNummer = folgeNummer++;
  }

  public int altersDifferenz (int alter) { 
    return Math.abs(alter - this.alter);
  }
 
  public boolean istLetzter () {
    return (verfolger == null);
  }
  
  public String toString () {
    String printText = name + " (" + startNummer + ")";
    if (verfolger != null)
      printText = printText + " liegt vor " + verfolger;
    return printText;
  }
  
  public int getStartNummer () {
    return startNummer;
  }
  public static int getFolgeNummer () {
    return folgeNummer;
  }
}

